/*
 * Picket Fence v1.4 header file.
 * See pfence.txt for usage and licence.
 */

/*
 * Uncomment to deactivate picket fence:
 */

//#define CALLOCMALLOC

#ifdef CALLOCMALLOC
#define malloc(a) calloc(a,1)
#endif

#define PICKETFENCE_H_INCLUDED

#ifndef PICKETFENCE_H_INCLUDED
#define PICKETFENCE_H_INCLUDED
/*
 * Global variables:
 */
extern int pfence_total_alloced;
extern int pfence_alloc_count;
/*
 * Replacement functions:
 */
extern void * pfence_alloc(int size, int row, char * fname);
extern void pfence_free(void * ptr);
extern void * pfence_realloc(void * oldmem, int newsize, int row, char * fname);
/*
 * Manual check call:
 */
extern void pfence_checkmemtree(void);
/*
 * Defines to replace std calls:
 */
#define malloc(n) pfence_alloc(n,__LINE__,__FILE__)
#define calloc(n,p) pfence_alloc((n)*(p),__LINE__,__FILE__)
#define realloc(n,p) pfence_realloc(n,p,__LINE__,__FILE__)
#endif
